/*
 * IRC - Internet Relay Chat, ircd/m_ircops.c
 * Copyright (C) 1990 Jarkko Oikarinen and
 *                    University of Oulu, Computing Center
 *
 * See file AUTHORS in IRC package for additional names of
 * the programmers.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: m_operlist.c,v 1.2 2003/11/23 19:00:00 styx Exp $
 */

#include "channel.h"
#include "config.h"
#include "client.h"
#include "handlers.h"
#include "hash.h"
#include "ircd.h"
#include "ircd_defs.h"
#include "ircd_features.h"
#include "ircd_reply.h"
#include "ircd_string.h"
#include "ircd_snprintf.h"
#include "ircd_alloc.h"
#include "list.h"
#include "msg.h"
#include "numeric.h"
#include "numnicks.h"
#include "querycmds.h"
#include "send.h"
#include "s_conf.h"
#include "s_user.h"
#include "s_debug.h"
#include "userload.h"
#include "patchlevel.h"

#include <string.h>
#include <ctype.h>
#include <stdlib.h>


/*
 *
 * m_operlist
 *
 * --StyX
 *
 */
int m_operlist(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
{
	struct Client *acptr;
	int admins = 0, opers = 0;
	char var_admins[400] = "", var_opers[400] = "";

	for (acptr = GlobalClientList; acptr; acptr = cli_next(acptr)) {
		if (!IsChannelService(acptr)) {
			if (IsAnAdmin(acptr)) {
				if (admins != 0)
					strcat(var_admins, ", ");
				strcat(var_admins, cli_name(acptr));
				admins++;
			}
			else if (IsAnOper(acptr)) {
				if (opers != 0)
					strcat(var_opers, ", ");
				strcat(var_opers, cli_name(acptr));
				opers++;
			}
		}
	}
	if (var_admins[0] != '\0')
		sendcmdto_one(&me, CMD_NOTICE, sptr, "%C :\002Liste des Administrateurs(s) :\002 %s", sptr, var_admins);
	else
		sendcmdto_one(&me, CMD_NOTICE, sptr, "%C :\002Aucun Administrateur connect\002", sptr);

	if (var_opers[0] != '\0')
		sendcmdto_one(&me, CMD_NOTICE, sptr, "%C :\002Liste des IRC Oprateur(s) :\002 %s", sptr, var_opers);
	else
		sendcmdto_one(&me, CMD_NOTICE, sptr, "%C :\002Aucun IRC Oprateur connect\002", sptr);

	sendcmdto_one(&me, CMD_NOTICE, sptr, "%C :Il y  %d Adminitrateur(s) et %d IRC Oprateur(s) sur le rseau,", sptr, admins, opers);

	sendcmdto_one(&me, CMD_NOTICE, sptr, "%C :Soit un total de %d oprateur(s) connects.", sptr, admins+opers);

	return 0;
}
